/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/__ASSETS__/scripts/bundle/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 213);
/******/ })
/************************************************************************/
/******/ ({

/***/ 213:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// const React = has been included in the iframe already
// const ReactDOM = has been included in the iframe already
/* global React, ReactDOM, SLDS */

var getContentOrigin = function getContentOrigin() {
  var _window$location = window.location,
      protocol = _window$location.protocol,
      host = _window$location.host;

  return protocol + '//' + host;
};

var Hoc = function (_React$Component) {
  _inherits(Hoc, _React$Component);

  function Hoc(props) {
    _classCallCheck(this, Hoc);

    var _this = _possibleConstructorReturn(this, (Hoc.__proto__ || Object.getPrototypeOf(Hoc)).call(this, props));

    _this.currentFound = [];
    return _this;
  }

  _createClass(Hoc, [{
    key: 'applyMods',
    value: function applyMods() {
      var _this2 = this;

      this.currentFound = [];
      var el = ReactDOM.findDOMNode(this);
      this.props.modifiers.forEach(function (m) {
        var r = el.querySelector(m.annotations.restrict);
        if (r) {
          _this2.currentFound.push([r, m]);
          r.classList.add(m.annotations.selector.slice(1));
        }
      });
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate() {
      this.currentFound.forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            r = _ref2[0],
            m = _ref2[1];

        return r.classList.remove(m.annotations.selector.slice(1));
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.applyMods();
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        null,
        this.props.children
      );
    }
  }]);

  return Hoc;
}(React.Component);

var dispatch = function dispatch(type, payload) {
  window.parent.postMessage({ type: type, payload: payload }, getContentOrigin());
};

var extractUrl = function extractUrl(url, cacheBuster) {
  return url.replace(/(.+?)(\?.+)?$/, function (match, u) {
    return u + '?cache=' + cacheBuster;
  });
};

var reloadScriptTag = function reloadScriptTag(script) {
  var newScript = document.createElement('script');
  newScript.id = script.id;
  newScript.src = extractUrl(script.src, Math.random(2));
  script.remove();
  document.head.appendChild(newScript);
};

var renderComponent = function renderComponent(payload, element) {
  var Component = payload.type === 'default' ? SLDS.default : SLDS[payload.type][payload.index].element;
  ReactDOM.render(React.createElement(
    Hoc,
    { modifiers: payload.modifiers },
    Component
  ), element);
};

var handlers = {
  styles: function styles(payload) {
    var link = document.querySelector('link');
    link.href = extractUrl(link.href, payload.styles);
  },
  bgColor: function bgColor(payload) {
    var preview = document.getElementById('previewer');
    preview.style.backgroundColor = payload.color;
  },
  markup: function markup(payload) {
    var preview = document.getElementById('previewer');
    reloadScriptTag(document.querySelector('#iframeScript'));
    setTimeout(function () {
      renderComponent(payload, preview);
      preview.setAttribute('style', 'padding: 0.5rem;');
      dispatch('iframe:height', {
        id: payload.id,
        height: preview.clientHeight
      });
    }, 1000); // jank as hell. Need to know when script tag has loaded
  }
};

window.addEventListener('message', function (e) {
  var _e$data = e.data,
      type = _e$data.type,
      payload = _e$data.payload;

  var handler = handlers[type];
  if (typeof handler === 'function') {
    handler(payload);
  }
});

/***/ })

/******/ });